/**
 * Filename: gcal.js
 * Author: Leslie Saputra
 **/
 
System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = SettingsClosed;
System.Gadget.onSettingsClosing = SettingsClosing;
 
/*********************************************************************************************************************/
// main gadget functions
var current_date = new Date();
var save_dir = System.Environment.getEnvironmentVariable("temp") + "\\";
var prefix = "gcal_feed";
var suffix = ".xml";
var new_feed = "New";
var ok_feed = "Ok";
var bad_feed = "Invalid";
var xmlRequest;
var current_index;
var current_url;
var flyout_date;
var download_status = new Array();
var entry_title = new Array();
var entry_date = new Array();
var calendar_total;

// month in string
var months = new Array("Jan", "Feb", "Mar", "Apr", 
					   "May", "Jun", "Jul", "Aug", 
					   "Sep", "Oct", "Nov", "Dec");

function onLoadCalendar() {
	setTimeout("RefreshCalendar(true)", 300000);
	RefreshCalendar();
}

function DecreaseMonth() {
	current_date = new Date(current_date.getYear(), current_date.getMonth() - 1, 1);
	ChangeMonth(current_date);
}

function IncreaseMonth() {
	current_date = new Date(current_date.getYear(), current_date.getMonth() + 1, 1);
	ChangeMonth(current_date);
}

function ShowDaily() {
	flyout_date = System.Gadget.document.parentWindow.flyout_date;
	entry_date = System.Gadget.document.parentWindow.entry_date;
	entry_title = System.Gadget.document.parentWindow.entry_title;
	calendar_total = System.Gadget.document.parentWindow.calendar_total;
	
	var titles = "<table>";
	titles += "<tr><th>" + months[flyout_date.getMonth()] + " " + flyout_date.getDate() + ", " + flyout_date.getYear() + "</th></tr>";
	
	for(var i = 0; i < calendar_total; i++)
	{		
		if(entry_date[i].getYear() == flyout_date.getYear() &&
		   entry_date[i].getMonth() - 1 == flyout_date.getMonth() &&
		   entry_date[i].getDate() == flyout_date.getDate())
		{
			var my_hour = "";
			if(entry_date[i].getHours() < 10)
				my_hour += "0";
			my_hour += entry_date[i].getHours();
			var my_min = "";
			if(entry_date[i].getMinutes() < 10)
				my_min += "0";
			my_min += entry_date[i].getMinutes();
			titles += "<tr><td>" + my_hour + ":" + my_min + " " + 
					  entry_title[i] + "</td></tr>";
		}
	}
	titles += "</table>";
	document.getElementById("daily_content").innerHTML = titles;
}

function ShowFlyout(table_data) 
{
	if(table_data.childNodes(0).childNodes(0).childNodes.length > 0)
	{
		flyout_date = new Date(current_date.getYear(),
							   current_date.getMonth(),
							   table_data.childNodes(0).childNodes(0).innerText);
	}
	else
	{
		flyout_date = new Date(current_date.getYear(),
							   current_date.getMonth(),
							   table_data.childNodes(0).innerText);
	}
	
	if(System.Gadget.Flyout.show == true) 
	{
		System.Gadget.Flyout.show = false;
	}
	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.Flyout.show = true;
	System.Gadget.Flyouy.onHide = blankFunction;
}

function ChangeMonth(select_date) {
	// to determine end of month
	var month_days = new Array(31,28,31,30,31,30,31,31,30,31,30,31);
	// figure out first of month and last of month
	var today = new Date();
	var first_of_month = new Date(select_date.getYear(), select_date.getMonth(), 1);
	var this_month_days = month_days[select_date.getMonth()];
	if (this_month_days == 1 && (this_month_days%400 == 0 || (this_month_days%4 == 0 && this_month_days%100 != 0)))
		this_month_days++;
	var last_of_month = new Date(select_date.getYear(), select_date.getMonth(), this_month_days);
	
	// find this month calendar begin and end date
	var first_day = first_of_month.getDay();
	var begin_date = new Date(first_of_month.getYear(), first_of_month.getMonth(), first_of_month.getDate() - first_day);
	var last_day = last_of_month.getDay();
	var end_date;
	if (last_day == 6) {
		end_date = last_of_month;
	} else {
		end_date = new Date(last_of_month.getYear(), last_of_month.getMonth(), last_of_month.getDate() + (6 - last_day));
	}
	
	// build html calendar
	var date_iterator = begin_date;
	var calendar_content = "<table cellspacing=\"0\" cellpadding=\"2\"><tr>" + 
						   "<th><a href=\"\" onclick=\"DecreaseMonth();\">&#171;</a></th>" + 
						   "<th colspan=\"5\">" + months[select_date.getMonth()] + " " + select_date.getYear() + "</th>" + 
						   "<th><a href=\"\" onclick=\"IncreaseMonth();\">&#187;</a></th></tr>";
	calendar_content += "<tr><td class=\"title\">Su</td><td class=\"title\">M</td><td class=\"title\">Tu</td><td class=\"title\">W</td><td class=\"title\">Th</td><td class=\"title\">F</td><td class=\"title\">Sa</td></tr>";
	var day = 0;
	var table_data;
	while(date_iterator <= end_date) {
		if(day == 0) {
			calendar_content += "<tr>";
		} else if (day == 7) {
			calendar_content += "</tr>";
			day = 0;
		}
		
		var internal_date = date_iterator.getDate();
		for(var i = 0; i < calendar_total; i++)
		{		
			if(entry_date[i].getYear() == date_iterator.getYear() &&
			   entry_date[i].getMonth() - 1 == date_iterator.getMonth() &&
			   entry_date[i].getDate() == date_iterator.getDate())
			{
				internal_date = "<b>" + date_iterator.getDate() + "</b>";
			}
		}
		
		if(today.getYear() == date_iterator.getYear() && 
		   today.getMonth() == date_iterator.getMonth() &&
		   today.getDate() == date_iterator.getDate()) {
			table_data = "<span class=\"today\">" + internal_date + "</span>";
		} else if(select_date.getMonth() != date_iterator.getMonth()) {
			table_data = "<span class=\"notcurrent\">" + internal_date + "</span>";
		} else {
			table_data = "<span>" + internal_date + "</span>";
		}
		
		if(today.getYear() == date_iterator.getYear() && 
		   today.getMonth() == date_iterator.getMonth() &&
		   today.getDate() == date_iterator.getDate()) {
			calendar_content += "<td class=\"today\" onclick=\"ShowFlyout(this);\">" + table_data + "</td>";
		} else if(day == 0 || day == 6) {
			calendar_content += "<td class=\"weekend\" onclick=\"ShowFlyout(this);\">" + table_data + "</td>";
		} else {
			calendar_content += "<td onclick=\"ShowFlyout(this);\">" + table_data + "</td>";
		}
		date_iterator = new Date(date_iterator.getYear(), date_iterator.getMonth(), date_iterator.getDate() + 1);
		day++;
	}
	calendar_content += "</table>";

	var cal = document.getElementById('calendar');
	cal.innerHTML = calendar_content;
}

function ReadCalendar(xml_file)
{
	var date_string;
	try 
	{
		var tags;
		for(var i = 0; i < xml_file.childNodes.length; i++)
		{
			tags = xml_file.childNodes(i).tagName;
			//if(tags == "title")
			//{
			//}
			if(tags == "entry")
			{
				for(var k = 0; k < xml_file.childNodes(i).childNodes.length; k++)
				{
					tags = xml_file.childNodes(i).childNodes(k).tagName;
					if(tags == "title")
					{
						entry_title[calendar_total] = xml_file.childNodes(i).childNodes(k).text;
					}
					else if(tags == "gd:when")
					{
						date_string = xml_file.childNodes(i).childNodes(k).getAttribute("startTime");
						// format 2006-12-22T18:00:00.000-06:00
						entry_date[calendar_total] = new Date(date_string.substr(0,4),
															  date_string.substr(5,2),
															  date_string.substr(8,2),
															  date_string.substr(11,2),
															  date_string.substr(14,2),
															  date_string.substr(17,2));
					}
					else if(tags == "gd:recurrence")
					{
						var lines = xml_file.childNodes(i).childNodes(k).text.split("\n");		
						for(var j = 0; j < lines.length; j++)
						{
							var pair = lines[j].split("=");
							if(pair[0] == "DTSTART;VALUE")
							{
								date_string = pair[1].split(":")[1];
								// format 20061111
								entry_date[calendar_total] = new Date(date_string.substr(0,4),
																	  date_string.substr(4,2),
																	  date_string.substr(6,2));
							}
						}
					}
				}
				if(entry_title[calendar_total] != null)
				{
					calendar_total++;
				}
			}
		}
	}
	catch(error)
	{
		MessageBox(error);
	}
}

function RefreshCalendar(refresh_all)
{
	var xml_file, items_count, filename, url;
	calendar_total = 0;
	var feeds_count = System.Gadget.Settings.read("FeedsCount");
	for(var i = 0; i < parseInt(feeds_count); i++)
	{
		url = System.Gadget.Settings.read(prefix + i);
		xml_file = ReadXML(prefix + i + suffix);
		if(!refresh_all && xml_file != null)
		{
			ReadCalendar(xml_file);
			download_status[i] = ok_feed;
		}
		else
		{
			download_status[i] = url;
		}
	}
	ChangeMonth(current_date);
	DownloadXML();
}

function SettingsClosed(event)
{
	if (typeof event.closeAction != "undefined")
    {
        if (event.closeAction == event.Action.commit)
        {
            RefreshCalendar(false);
        }
    }
    else
    {
        RefreshCalendar(false);
    }
}

/*********************************************************************************************************************/
// setting functions
function FeedsIterator(function_to_execute, default_value)
{
	var feeds_count = System.Gadget.Settings.read("FeedsCount");
	if(feeds_count == "")
	{
		// default
		feeds_count = default_value;
	}
	
	var feeds_xml;
	for(var i = 0; i < parseInt(feeds_count); i++)
	{
		feeds_xml = System.Gadget.Settings.read(prefix + i);
		if(feeds_xml != "" || i == 0)
			eval(function_to_execute + "(feeds_xml)");
	}
}

function LoadSettings()
{
	FeedsIterator("AddFeed", "1");
}

function AddFeed(p_value) 
{
	var last_count = document.getElementsByName("feeds").length;
	if(last_count <= 7)
	{
		var container = document.getElementById("feeds_container");
		if(p_value == null)
			p_value = "";
		container.innerHTML += (last_count + 1) + ". <input type=\"text\" name=\"feeds\" maxlength=\"200\" size=\"40\" value=\"" + p_value + "\" onchange=\"URLChange(this);\" /><br />";
		var status;
		if(p_value == "")
			status = new_feed;
		else
			status = ok_feed;
		container.innerHTML += "&nbsp;&nbsp;&nbsp; Feed Status: <input type=\"text\" name=\"results\" value=\"" + status + "\" disabled=\"true\" size=\"10\" /><br />";
	}
	if(last_count >= 7)
	{
		document.getElementById("add").disabled = true;
	}
	document.getElementsByName("feeds")[last_count].focus();
	document.getElementsByName("feeds")[last_count].select();
}

function URLChange(obj)
{
	var feeds = document.getElementsByName("feeds");
	var results = document.getElementsByName("results");
	for(var i = 0; i < feeds.length; i++)
	{
		if(feeds[i] = obj)
		{
			results[i].value = new_feed;
		}
	}
}

function SettingsClosing(event)
{
	if (event.closeAction == event.Action.commit)
	{
		var feeds = document.getElementsByName("feeds");
		for(var i = 0; i < feeds.length; i++)
		{
			System.Gadget.Settings.write(prefix + i, feeds[i].value);
		}
		System.Gadget.Settings.write("FeedsCount", i);
	}
}

/*********************************************************************************************************************/
// general functions
function MessageBox(error)
{
	var shell_script = new ActiveXObject( 'WScript.Shell' );
	shell_script.popup(error);
}

function ReadXML(filename, error)
{
	try 
	{
		var doc = new ActiveXObject("Microsoft.XMLDOM");
		doc.async = "false";
		doc.load(save_dir + filename);
		
		if(doc.parseError != 0)
		{
			error = doc.parseError.reason; 
			return null;
		}
		return doc.documentElement;
	}
	catch (err)
	{
		error = err.message;
		return null;
	}
}

function DownloadXML()
{
	current_index = -1;
	for(var i = 0; i < download_status.length; i++)
	{
		if(download_status[i] != ok_feed && current_index == -1)
		{
			current_index = i;
			current_url = download_status[i];
		}
	}
	if(current_index == -1)
	{
		ChangeMonth(current_date);
		return;
	}
	
	xmlRequest = new ActiveXObject("Microsoft.XMLHTTP");
	xmlRequest.onreadystatechange = function ()
	{
		if(xmlRequest.readyState == 4 && xmlRequest.status == 200)
		{
			var doc = new ActiveXObject("Microsoft.XMLDOM");
			doc.loadXML(xmlRequest.responseText);
			doc.save(save_dir + prefix + current_index + suffix);
			
			var xml_file = ReadXML(prefix + current_index + suffix);
			ReadCalendar(xml_file);
			
			download_status[current_index] = ok_feed;
			DownloadXML();
		}
	}
	if(current_url.substr(current_url.length - 5, current_url.length) == "basic")
	{
		xmlRequest.open("GET", current_url.substr(0, current_url.length - 5) + "full", true);
	}
	else
	{
		xmlRequest.open("GET", current_url, true);
	}
	xmlRequest.send();
}

function CancelDownloading()
{
	xmlRequest.abort();
}

/*********************************************************************************************************************/
